;https://www.chibiakumas.com/z80/platform6.php#LessonP58
;https://www.petecodes.co.uk/sam-coupe-sprite-editor/
	device zxspectrum48
	org $8000
begin
mappl equ $6000
keeppl equ mappl+$300
	di
	ld a,%01101110; for mode4, value for mode3 01001110
	out (252),a ;VMPR - Video Memory Page Register
; Page in Vram
	ld a,%00101110 ;/R=ram in high area/B=low ram Bank
	out (250),a ;LMPR - Low Memory Page Register
	ld sp,$BFFF
;set colors
	ld bc,$0EF8
	ld a,17;111
	out (c),a
	call cls
	ld ix,msg4
	call tout
keyinp:
	ld c,$FE
	ld e,0
	ld hl,keyta
kelp:
	ld b,(hl)
	inc hl
	in a,(c)
	and (hl)
	jr z,gotkey
	inc hl
	inc e
	bit 4,e
	jr z,kelp
	jr keyinp

gotkey:
;	jr $
	ld a,e
	ld (ln),a
gamelp:
	call cls
	call depack
	call putplr
;draw level number
	ld de,(ln),d,0,hl,decnum
	add hl,de
	ld a,(hl),(l_n),a
;	ld hl,decnum2
;	add hl,de
;	ld a,(hl),(l_n+1),a
	ld ix,msgl
	call tout

;	jp endlvl
;	jr $
keylp:
	ld de,(mxy)
	call mapadr
;QWE-012 $FB
	ld a,$FB:in a,($FE)
	bit 0,a:jp z,keyq
	bit 1,a:jp z,keyw
	bit 2,a:jp z,keye
;AD-02 FD
	ld a,$FD:in a,($FE)
	bit 0,a:jp z,keya
	bit 2,a:jp z,keyd
;ZXC-123 $FE
	ld a,$FE:in a,($FE)
	bit 1,a:jp z,keyz
	bit 2,a:jp z,keyx
	bit 3,a:jp z,keyc
	jp keylp
keylp1:
	xor a
	in a,($FE)
	cpl
	and 31
	jr nz,keylp1
	jp keylp
;QWE
;A D
;ZXC
keyq:
	inc e; pX<>0
	dec e
	jp z,keylp
	inc d;pY<>0
	dec d
	jp z,keylp
;can move to block
	ld a,(ix-21)
	cp 4
	jp z,keylp
	ld bc,$FFFF;dy.dx
	jp movepl

keyw:
	inc d;pY<>0
	dec d
	jp z,keylp
;can move to block
	ld a,(ix-20)
	cp 4
	jp z,keylp
	ld bc,$FF00;dy.dx
	jp movepl

keye:
	inc d;pY<>0
	dec d
	jp z,keylp
	ld a,e;pX<>19
	cp 19
	jp z,keylp
	ld a,(ix-19)
	cp 4
	jp z,keylp
	ld bc,$FF01;dy.dx
	jp movepl

keya:
	inc e; pX<>0
	dec e
	jp z,keylp
	ld a,(ix-1)
	cp 4
	jp z,keylp
	ld bc,$00FF;dy.dx
	jp movepl

keyd:
	ld a,e;pX<>19
	cp 19
	jp z,keylp
	ld a,(ix+1)
	cp 4
	jp z,keylp
	ld bc,$0001;dy.dx
	jp movepl

keyz:
	inc e;pX<>0
	dec e
	jp z,keylp
	ld a,d; pY<>15
	cp 15
	jp z,keylp
	ld a,(ix+19)
	cp 4
	jp z,keylp
	ld bc,$01FF;dy.dx
	jp movepl

keyx:
	ld a,d; pY<>15
	cp 15
	jp z,keylp
	ld a,(ix+20)
	cp 4
	jp z,keylp
	ld bc,$0100;dy.dx
	jp movepl

keyc:
	ld a,e;pX<>19
	cp 19
	jp z,keylp
	ld a,d; pY<>15
	cp 15
	jp z,keylp
	ld a,(ix+21)
	cp 4
	jp z,keylp
	ld bc,$0101;dy.dx
	jp movepl


; move player with direction
movepl:
	ld (dxdy),bc
startm:
	ld b,4
smlp:
	push bc
pause:	IN	A,(249); Pause for a frame
	BIT	3,A
	JR	NZ,pause
	ld hl,(pxy)
	srl h
	rr l
	ld de,keeppl
	call tileblock;DE=tile addr,HL=screen addr
	ld de,(pxy)
	ld bc,(dxdy)
	ld a,d
	add a,b
	add a,b
	ld d,a
	ld a,e
	add a,c
	add a,c
	ld e,a
	ld (pxy),de
	call putplr
	pop bc
	djnz smlp
;check direction
;0-empty
;1-circle stop
;2-diamond
;3-bomb
;4-block
;	ld de,(mxy)
;	ld bc,(dxdy)
	call deplusbc1;DE+BC, map coordinates +dx.dy
	ld (mxy),de
	call mapadr
cas0:
	ld a,(ix+0)
	or a:jp nz,cas1

	call deplusbc1
;?bound check
	ld a,e
	cp $FF:jp z,keylp1
	cp 20:jp z,keylp1
	ld a,d
	cp $FF:jp z,keylp1
	cp 16:jp z,keylp1
;
	call mapadr
	ld a,(ix+0)
	cp 4: jp z,keylp1
	jp startm
cas1:
	cp 1:jp z,keylp1
	cp 2:jp nz,case3;diamond
	ld (ix+0),0
	call checklvl
	jr z,not_done
endlvl:
	ld ix,msg3
	call tout
	call spacek
	ld a,(ln)
	inc a
	and 15
	ld (ln),a
	jp gamelp
;	jr $
not_done:
	ld de,keeppl,bc,32,hl,tile0:ldir
	
	call deplusbc1
;?bound check
	ld a,e
	cp $FF:jp z,keylp1
	cp 20:jp z,keylp1
	ld a,d
	cp $FF:jp z,keylp1
	cp 16:jp z,keylp1
;
	call mapadr
	ld a,(ix+0)
	cp 4: jp z,keylp1
	jp startm
case3: ;bomb
	ld de,tile5
	ld hl,(pxy)
	srl h
	rr l
	call tileblock;DE=tile addr,HL=screen addr
	ld ix,msg2
	call tout
	call spacek
	jp gamelp
;	jr $
;	jp keylp1

;VARS
dxdy:dw 0 ; deltas for direction move
mxy: dw 0 ; map coords
pxy: dw 0 ; screen cooards
ln: db 0; level number
;------R O U T I N E S------
checklvl:
	ld hl,mappl
	ld bc,320
chelp:
	ld a,(hl)
	cp 2:ret z
	inc hl
	dec bc
	ld a,b:or c
	jr nz,chelp
	inc b
	ret
spacek:
	ld a,$7f:in a,($FE)
	rra:jr c,spacek
	ret
tout:
	ld e,(ix+0)
	ld d,(ix+1)
	ld c,(ix+2)
	inc ix,ix,ix
tolp:
	push de
	ld l,(ix+0)
	ld h,0
	ld de,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	pop de

	push de
	ld b,8
chalp:
	bit 7,(hl):jr z,noput7
	ld a,(de)
	xor c
	and $0F
	xor c
	ld (de),a
noput7:
	bit 6,(hl):jr z,noput6
	ld a,(de)
	xor c
	and $F0
	xor c
	ld (de),a
noput6:
	inc de
	bit 5,(hl):jr z,noput5
	ld a,(de)
	xor c
	and $0F
	xor c
	ld (de),a
noput5:
	bit 4,(hl):jr z,noput4
	ld a,(de)
	xor c
	and $F0
	xor c
	ld (de),a
noput4:
	inc de
	bit 3,(hl):jr z,noput3
	ld a,(de)
	xor c
	and $0F
	xor c
	ld (de),a
noput3:
	bit 2,(hl):jr z,noput2
	ld a,(de)
	xor c
	and $F0
	xor c
	ld (de),a
noput2:
	inc de
	bit 1,(hl):jr z,noput1
	ld a,(de)
	xor c
	and $0F
	xor c
	ld (de),a
noput1:
	bit 0,(hl):jr z,noput0
	ld a,(de)
	xor c
	and $F0
	xor c
	ld (de),a
noput0:
	inc de
	ld a,e
	add a,124
	ld e,a
	jr nc,noincd
	inc d
noincd:
	inc hl
	dec b
	jp nz, chalp
	pop de
	inc de,de,de,de
	inc ix
	ld a,(ix+0)
	or a
	jp nz,tolp
	ret
	
deplusbc1:
	ld de,(mxy)
	ld bc,(dxdy)
deplusbc:
	ld a,d
	add a,b
	ld d,a
	ld a,e
	add a,c
	ld e,a
	ret
mapadr: ; in:DE=y.x, out:IX=address
	push hl
	push bc
	ld l,d
	ld h,0
	ld bc,hl
;*20
	add hl,hl;*2
	add hl,hl;*4
	add hl,bc;*5
	add hl,hl;*10
	add hl,hl;*20
	ld b,0,c,e
	add hl,bc
	ld bc,mappl
	add hl,bc
	push hl
	pop ix
	pop bc
	pop hl
	ret
putplr:
	ld hl,plyr ;mask
;	ld de,128*8 ; screen
	ld de,(pxy)
	or a
	rr d
	rr e
	ld bc, keeppl
	ld a,8
pulp:
	exa
	ld a,(de),(bc),a:and (hl):inc hl:or (hl):inc hl:ld (de),a:inc de,bc
	ld a,(de),(bc),a:and (hl):inc hl:or (hl):inc hl:ld (de),a:inc de,bc
	ld a,(de),(bc),a:and (hl):inc hl:or (hl):inc hl:ld (de),a:inc de,bc
	ld a,(de),(bc),a:and (hl):inc hl:or (hl):inc hl:ld (de),a:inc de,bc
	push bc
	ex de,hl
	ld bc,124
	add hl,bc
	ex de,hl
	pop bc
	exa
	dec a
	jr nz,pulp
	ret

cls:
	ld hl,0
clslp:
	ld (hl),0:inc hl
	bit 7,h
	jr z,clslp
	ret
	
depack:
	ld hl,(ln),h,0,de,levt
	add hl,hl
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	push de
	pop ix;ld ix,lev1
	ld a,(ix+0):inc ix
	ld (mxy),a
	add a,a
	add a,a
	add a,a
	add a,48
	ld (pxy),a
	ld a,(ix+0):inc ix
	ld (mxy+1),a
	add a,a
	add a,a
	add a,a
	add a,32
	ld (pxy+1),a

	ld hl,mappl
	ld b,160
depl:
	ld a,(ix+0)
	srl a
	srl a
	srl a
	srl a
	ld (hl),a:inc hl
	ld a,(ix+0)
	and $0F
	inc ix
	ld (hl),a:inc hl
	djnz depl
;draw
	ld ix,mappl
	ld hl,24+32*128
	ld c,16
drwly:
	ld b,20
	push hl
drwlx:
	push hl
	ld l,(ix+0)
	ld h,0
	inc ix
	ld de,tile0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ex de,hl
	pop hl
	call tileblock;DE=tile addr,HL=screen addr
	inc hl,hl,hl,hl
	dec b
	jp nz,drwlx
	pop hl
	ld de,128*8
	add hl,de
	dec c
	jp nz,drwly
	ret
tileblock:
;DE=tile addr,HL=screen addr
	push hl
	push bc
	ld b,8

tilel:
	ld a,(de),(hl),a:inc de,hl
	ld a,(de),(hl),a:inc de,hl
	ld a,(de),(hl),a:inc de,hl
	ld a,(de),(hl),a:inc de,hl
	push bc
	ld bc,124
	add hl,bc
	pop bc
	djnz tilel

	pop bc
	pop hl
	ret

;tiles:
tile0: ;empty
	db $77,$77,$77,$77
	db $77,$77,$77,$77
	db $77,$77,$77,$77
	db $77,$77,$77,$77
	db $77,$77,$77,$77
	db $77,$77,$77,$77
	db $77,$77,$77,$77
	db $77,$77,$77,$77
tile1: ; circle stop
	db $77,$77,$77,$77
	db $70,$77,$70,$77
	db $07,$77,$77,$07
	db $77,$77,$77,$77
	db $77,$77,$77,$77
	db $77,$77,$77,$77
	db $07,$77,$77,$07
	db $70,$77,$70,$77
tile2:;diamond
	db $77,$77,$77,$77
	db $77,$70,$77,$77
	db $77,$0D,$07,$77
	db $70,$DD,$D0,$77
	db $0D,$DD,$DD,$07
	db $70,$DD,$D0,$77
	db $77,$0D,$07,$77
	db $77,$70,$77,$77
tile3:;bomb
	db $77,$77,$77,$77
	db $77,$70,$07,$77
	db $77,$00,$00,$77
	db $70,$FF,$00,$07
	db $00,$FF,$00,$07
	db $70,$00,$00,$07
	db $77,$00,$00,$77
	db $77,$70,$07,$77

tile4:;block
	db $77,$77,$77,$77
	db $7F,$FF,$FF,$F7
	db $7F,$FF,$FF,$F0
	db $7F,$FF,$FF,$F0
	db $7F,$FF,$FF,$F0
	db $7F,$FF,$FF,$F0
	db $7F,$FF,$FF,$F0
	db $77,$00,$00,$00
tile5: ; explode
	db $77,$77,$77,$77
	db $77,$77,$A7,$77
	db $77,$A7,$A7,$A7
	db $77,$7A,$AA,$77
	db $7A,$AA,$AA,$AA
	db $77,$7A,$AA,$77
	db $77,$A7,$A7,$A7
	db $77,$77,$A7,$77
plyr:
	db $FF,$00,$FF,$00,$FF,$00,$FF,$00
	db $FF,$00,$00,$CC,$0F,$C0,$FF,$00
	db $F0,$0C,$00,$CC,$00,$CC,$FF,$00
	db $00,$CC,$00,$CC,$00,$CC,$0F,$C0
	db $00,$CC,$00,$CC,$00,$CC,$0F,$C0
	db $00,$CC,$00,$CC,$00,$CC,$0F,$C0
	db $F0,$0C,$00,$CC,$00,$CC,$FF,$00
	db $FF,$00,$00,$CC,$0F,$C0,$FF,$00

;-----------------packed levels--------------
levt:
 dw lev1,lev2,lev3,lev4,lev5,lev6,lev7,lev8,lev9,lev10,lev11,lev12
 dw lev13,lev14,lev15,lev16
lev1:
 db 0;X
 db 9;Y
 db $03,$01,$31,$33,$42,$10,$20,$44,$02,$02;1
 db $11,$01,$10,$30,$42,$13,$24,$30,$22,$34;2
 db $20,$04,$11,$03,$03,$23,$12,$13,$21,$30;3
 db $01,$03,$40,$12,$14,$14,$44,$23,$41,$10;4
 db $03,$41,$13,$41,$24,$40,$20,$44,$00,$34;5
 db $21,$32,$23,$34,$42,$00,$14,$34,$12,$43;6
 db $23,$11,$14,$12,$01,$33,$31,$44,$02,$02;7
 db $34,$31,$10,$21,$10,$41,$21,$00,$23,$22;8
 db $30,$04,$03,$40,$31,$14,$24,$20,$30,$31;9
 db $13,$41,$32,$14,$41,$31,$01,$11,$42,$20;10
 db $21,$02,$02,$00,$40,$22,$24,$31,$30,$13;11
 db $22,$13,$41,$41,$20,$43,$34,$20,$34,$44;12
 db $43,$01,$21,$13,$24,$20,$44,$21,$24,$40;13
 db $03,$00,$41,$41,$30,$24,$43,$34,$22,$24;14
 db $43,$22,$23,$30,$33,$02,$41,$12,$43,$34;15
 db $21,$23,$32,$10,$00,$33,$20,$12,$34,$03;16

lev2:
 db 6;X
 db 4;Y
 db $44,$30,$21,$23,$34,$43,$04,$03,$11,$40;1
 db $00,$20,$24,$02,$22,$11,$00,$32,$31,$12;2
 db $24,$23,$30,$42,$11,$32,$34,$23,$20,$34;3
 db $10,$10,$34,$01,$42,$14,$34,$34,$33,$43;4
 db $01,$42,$03,$10,$13,$13,$44,$11,$20,$40;5
 db $32,$14,$04,$12,$00,$40,$42,$13,$13,$40;6
 db $42,$42,$40,$11,$13,$22,$41,$41,$44,$32;7
 db $42,$33,$43,$20,$04,$31,$31,$23,$43,$13;8
 db $42,$04,$13,$01,$42,$14,$04,$21,$02,$02;9
 db $01,$12,$21,$23,$32,$13,$11,$30,$44,$02;10
 db $22,$12,$44,$04,$40,$42,$41,$03,$12,$21;11
 db $00,$40,$03,$12,$11,$24,$42,$03,$12,$21;12
 db $31,$43,$24,$23,$12,$23,$32,$31,$03,$03;13
 db $42,$33,$14,$01,$20,$31,$20,$04,$23,$03;14
 db $10,$34,$21,$20,$33,$20,$20,$10,$41,$03;15
 db $10,$34,$40,$14,$13,$30,$04,$11,$20,$30;16

lev3:
 db 14
 db 0
 db $10,$13,$24,$30,$20,$11,$24,$13,$12,$21;1
 db $01,$30,$31,$33,$21,$23,$20,$43,$10,$24;2
 db $22,$20,$03,$34,$03,$32,$43,$44,$41,$43;3
 db $31,$40,$42,$01,$43,$30,$03,$21,$14,$10;4
 db $33,$31,$24,$13,$21,$04,$32,$10,$20,$12;5
 db $14,$21,$34,$10,$10,$30,$21,$42,$42,$30;6
 db $22,$32,$10,$44,$30,$13,$44,$14,$22,$02;7
 db $44,$11,$31,$30,$00,$12,$01,$31,$13,$41;8
 db $31,$23,$12,$23,$44,$14,$40,$40,$10,$02;9
 db $10,$24,$32,$14,$32,$24,$30,$42,$11,$13;10
 db $14,$42,$41,$00,$34,$10,$02,$44,$23,$13;11
 db $41,$10,$40,$22,$23,$01,$13,$10,$14,$04;12
 db $22,$13,$24,$32,$33,$34,$11,$13,$14,$33;13
 db $23,$40,$32,$24,$30,$40,$22,$32,$02,$04;14
 db $14,$30,$00,$02,$00,$44,$22,$43,$33,$23;15
 db $20,$41,$41,$03,$40,$04,$22,$40,$00,$04;16

lev4:
 db 14
 db 5
 db $32,$14,$30,$40,$22,$24,$23,$32,$31,$03;1
 db $40,$42,$43,$02,$14,$21,$30,$34,$04,$43;2
 db $40,$11,$11,$40,$01,$43,$24,$23,$12,$43;3
 db $13,$02,$02,$14,$14,$40,$20,$04,$32,$01;4
 db $22,$21,$44,$02,$40,$11,$00,$30,$33,$22;5
 db $23,$13,$03,$40,$10,$21,$12,$10,$04,$01;6
 db $42,$10,$04,$31,$33,$01,$21,$22,$24,$21;7
 db $33,$20,$42,$44,$34,$23,$43,$30,$33,$41;8
 db $42,$44,$42,$01,$12,$04,$13,$41,$13,$14;9
 db $12,$20,$13,$02,$31,$34,$01,$33,$20,$30;10
 db $14,$32,$21,$33,$13,$04,$30,$40,$21,$12;11
 db $11,$10,$11,$23,$23,$41,$34,$30,$40,$14;12
 db $10,$42,$04,$14,$03,$10,$42,$34,$23,$33;13
 db $20,$12,$01,$40,$43,$42,$22,$34,$42,$13;14
 db $03,$20,$04,$03,$04,$12,$41,$22,$01,$10;15
 db $24,$00,$33,$02,$20,$43,$12,$43,$31,$11;16


lev5:
 db 8
 db 8
 db $22,$21,$41,$32,$20,$31,$33,$44,$32,$04;1
 db $41,$11,$41,$03,$12,$21,$24,$34,$03,$31;2
 db $10,$03,$30,$10,$22,$24,$43,$12,$40,$00;3
 db $24,$00,$22,$01,$04,$23,$22,$13,$20,$30;4
 db $14,$43,$43,$12,$43,$04,$14,$22,$03,$40;5
 db $31,$44,$31,$43,$32,$22,$12,$12,$12,$34;6
 db $22,$24,$40,$31,$11,$03,$40,$33,$21,$32;7
 db $12,$00,$01,$34,$40,$40,$30,$11,$44,$13;8
 db $13,$13,$10,$23,$13,$00,$20,$12,$00,$20;9
 db $20,$14,$13,$12,$23,$43,$12,$23,$34,$42;10
 db $14,$33,$41,$22,$00,$33,$40,$20,$34,$23;11
 db $11,$14,$02,$41,$41,$24,$01,$44,$31,$10;12
 db $20,$41,$01,$10,$44,$33,$41,$24,$34,$24;13
 db $43,$30,$24,$40,$00,$32,$34,$21,$04,$40;14
 db $20,$10,$03,$13,$33,$21,$10,$21,$20,$02;15
 db $40,$33,$30,$13,$01,$22,$04,$13,$14,$44;16

lev6:
 db 18
 db 7
 db $34,$22,$23,$03,$42,$40,$44,$10,$30,$40;1
 db $30,$11,$03,$32,$42,$32,$43,$43,$21,$40;2
 db $02,$22,$32,$01,$14,$20,$23,$02,$22,$40;3
 db $23,$41,$30,$11,$44,$43,$31,$21,$20,$13;4
 db $30,$11,$43,$24,$23,$11,$04,$44,$01,$24;5
 db $20,$03,$44,$03,$24,$30,$30,$24,$43,$31;6
 db $40,$11,$11,$22,$02,$30,$11,$30,$41,$22;7
 db $33,$21,$13,$40,$34,$03,$00,$43,$10,$13;8
 db $42,$22,$03,$31,$12,$31,$24,$30,$02,$03;9
 db $01,$21,$40,$30,$32,$11,$01,$41,$14,$30;10
 db $32,$41,$30,$14,$04,$41,$42,$43,$02,$42;11
 db $13,$11,$43,$23,$32,$42,$14,$10,$42,$03;12
 db $14,$04,$21,$22,$01,$00,$12,$12,$40,$41;13
 db $32,$21,$01,$40,$41,$03,$34,$23,$03,$34;14
 db $40,$34,$24,$01,$20,$24,$13,$12,$22,$00;15
 db $14,$12,$04,$03,$10,$32,$13,$14,$33,$41;16

lev7:
 db 13
 db 9
 db $21,$42,$40,$04,$22,$20,$40,$44,$14,$32;1
 db $34,$24,$42,$40,$12,$24,$43,$34,$23,$30;2
 db $40,$21,$24,$33,$31,$34,$42,$13,$20,$24;3
 db $00,$04,$20,$33,$13,$30,$20,$01,$11,$22;4
 db $41,$20,$20,$40,$02,$13,$10,$00,$34,$14;5
 db $23,$23,$40,$30,$00,$03,$44,$31,$20,$34;6
 db $33,$00,$02,$10,$33,$31,$20,$32,$34,$10;7
 db $40,$03,$24,$41,$33,$01,$30,$31,$41,$13;8
 db $11,$44,$11,$23,$31,$20,$02,$04,$02,$04;9
 db $42,$11,$10,$01,$12,$33,$01,$40,$14,$32;10
 db $41,$10,$44,$03,$14,$03,$00,$22,$44,$40;11
 db $22,$14,$12,$31,$31,$03,$40,$42,$12,$40;12
 db $02,$23,$21,$23,$12,$42,$14,$31,$32,$11;13
 db $32,$31,$41,$31,$21,$33,$12,$10,$02,$40;14
 db $41,$23,$00,$31,$13,$22,$21,$01,$24,$34;15
 db $24,$23,$44,$34,$13,$42,$21,$34,$31,$11;16

lev8:
 db 19
 db 11
 db $11,$12,$14,$10,$22,$20,$21,$00,$12,$10;1
 db $34,$03,$30,$42,$40,$03,$04,$04,$03,$32;2
 db $00,$03,$41,$43,$40,$20,$13,$10,$42,$32;3
 db $30,$33,$14,$02,$23,$21,$31,$22,$44,$10;4
 db $32,$00,$41,$44,$22,$20,$23,$23,$41,$34;5
 db $31,$11,$23,$01,$43,$04,$44,$10,$31,$32;6
 db $41,$00,$34,$21,$22,$02,$24,$24,$23,$13;7
 db $14,$42,$12,$10,$01,$30,$02,$24,$12,$13;8
 db $24,$41,$44,$23,$10,$23,$03,$30,$33,$40;9
 db $11,$30,$44,$33,$43,$41,$22,$00,$23,$13;10
 db $43,$43,$32,$33,$42,$23,$30,$41,$24,$21;11
 db $00,$43,$41,$24,$14,$21,$20,$12,$03,$01;12
 db $03,$11,$13,$02,$32,$23,$33,$11,$21,$04;13
 db $41,$31,$34,$13,$00,$34,$31,$44,$14,$10;14
 db $03,$13,$14,$10,$24,$23,$00,$02,$21,$44;15
 db $24,$24,$01,$21,$42,$41,$00,$04,$21,$40;16

lev9:
 db 3
 db 6
 db $40,$33,$03,$04,$23,$22,$22,$44,$03,$30;1
 db $14,$00,$44,$30,$10,$44,$33,$14,$11,$20;2
 db $03,$24,$11,$20,$02,$21,$21,$12,$32,$42;3
 db $34,$11,$42,$41,$43,$43,$13,$04,$03,$40;4
 db $11,$04,$34,$13,$30,$04,$40,$33,$44,$04;5
 db $13,$32,$30,$21,$34,$13,$03,$04,$24,$11;6
 db $14,$41,$12,$01,$03,$00,$44,$03,$00,$00;7
 db $21,$20,$01,$03,$20,$44,$33,$22,$31,$12;8
 db $00,$41,$20,$10,$44,$02,$12,$12,$12,$23;9
 db $23,$22,$20,$03,$44,$14,$13,$13,$11,$44;10
 db $13,$21,$34,$32,$24,$14,$41,$30,$00,$22;11
 db $42,$31,$40,$22,$32,$04,$03,$32,$04,$12;12
 db $22,$10,$10,$12,$01,$11,$33,$13,$20,$23;13
 db $11,$30,$42,$04,$11,$32,$40,$42,$24,$43;14
 db $11,$32,$32,$12,$32,$30,$24,$43,$10,$31;15
 db $14,$04,$32,$30,$32,$32,$44,$01,$23,$14;16

lev10:
 db 7
 db 15
 db $02,$31,$13,$40,$24,$23,$02,$24,$30,$10;1
 db $03,$43,$12,$32,$12,$12,$41,$41,$14,$33;2
 db $12,$13,$00,$14,$24,$23,$21,$21,$20,$30;3
 db $01,$23,$24,$10,$14,$04,$14,$23,$20,$24;4
 db $01,$22,$43,$20,$03,$03,$03,$12,$13,$31;5
 db $13,$21,$40,$12,$01,$32,$34,$30,$43,$13;6
 db $30,$33,$43,$44,$14,$14,$40,$33,$21,$31;7
 db $42,$44,$14,$12,$22,$31,$00,$21,$22,$32;8
 db $11,$00,$24,$20,$24,$00,$34,$11,$42,$01;9
 db $41,$44,$10,$42,$03,$10,$03,$31,$23,$10;10
 db $43,$30,$22,$42,$44,$00,$00,$32,$02,$41;11
 db $32,$13,$31,$23,$40,$33,$33,$10,$34,$24;12
 db $33,$01,$44,$40,$02,$42,$02,$14,$40,$43;13
 db $12,$20,$10,$40,$31,$02,$34,$42,$44,$34;14
 db $11,$10,$42,$30,$44,$32,$22,$00,$34,$04;15
 db $01,$11,$42,$11,$03,$31,$23,$01,$20,$41;16

lev11:
 db 13
 db 9
 db $21,$24,$13,$22,$32,$13,$12,$13,$44,$22;1
 db $10,$12,$24,$00,$02,$01,$43,$33,$00,$21;2
 db $03,$21,$21,$40,$04,$10,$12,$04,$11,$23;3
 db $11,$43,$01,$00,$33,$13,$12,$40,$22,$32;4
 db $23,$20,$34,$33,$02,$41,$40,$12,$14,$11;5
 db $13,$21,$41,$30,$40,$02,$12,$42,$04,$21;6
 db $41,$21,$42,$43,$33,$00,$42,$04,$44,$33;7
 db $32,$13,$41,$33,$41,$22,$14,$42,$42,$10;8
 db $20,$20,$33,$10,$30,$40,$14,$11,$41,$40;9
 db $11,$44,$04,$41,$22,$21,$01,$04,$02,$02;10
 db $41,$41,$34,$00,$43,$34,$43,$20,$30,$31;11
 db $00,$30,$33,$33,$44,$34,$23,$13,$31,$24;12
 db $24,$24,$44,$20,$30,$03,$12,$31,$04,$23;13
 db $02,$33,$13,$04,$12,$04,$24,$31,$30,$20;14
 db $11,$30,$12,$11,$34,$01,$24,$40,$23,$00;15
 db $02,$12,$33,$34,$02,$23,$14,$02,$43,$40;16

lev12:
 db 13
 db 3
 db $43,$32,$43,$30,$12,$12,$44,$04,$02,$32;1
 db $43,$00,$04,$12,$32,$12,$04,$10,$03,$20;2
 db $23,$32,$21,$31,$40,$03,$44,$43,$31,$44;3
 db $11,$12,$31,$04,$30,$30,$01,$21,$11,$03;4
 db $24,$44,$12,$01,$04,$30,$30,$41,$10,$20;5
 db $20,$22,$12,$14,$40,$00,$01,$41,$43,$24;6
 db $42,$32,$21,$42,$14,$44,$04,$13,$02,$22;7
 db $13,$13,$00,$02,$02,$02,$31,$24,$31,$13;8
 db $42,$22,$40,$13,$02,$14,$02,$43,$41,$04;9
 db $11,$24,$32,$43,$44,$03,$41,$24,$03,$00;10
 db $30,$42,$10,$32,$33,$30,$31,$43,$32,$13;11
 db $04,$13,$04,$00,$41,$41,$31,$30,$20,$22;12
 db $41,$14,$31,$13,$32,$30,$21,$11,$21,$12;13
 db $20,$43,$13,$23,$10,$14,$13,$12,$12,$34;14
 db $44,$30,$34,$41,$32,$41,$40,$22,$40,$12;15
 db $14,$04,$20,$23,$23,$13,$20,$32,$03,$03;16

lev13:
 db 10
 db 8
 db $31,$34,$32,$00,$21,$12,$00,$40,$34,$33;1
 db $00,$32,$12,$41,$44,$23,$40,$43,$33,$24;2
 db $11,$12,$22,$10,$02,$32,$21,$30,$14,$12;3
 db $11,$12,$12,$40,$21,$14,$24,$44,$20,$32;4
 db $22,$41,$14,$23,$01,$13,$02,$41,$00,$14;5
 db $10,$33,$34,$41,$33,$30,$43,$23,$00,$34;6
 db $20,$14,$13,$10,$04,$42,$22,$41,$31,$43;7
 db $22,$00,$04,$24,$00,$32,$43,$43,$23,$31;8
 db $13,$34,$21,$00,$24,$11,$02,$12,$31,$42;9
 db $10,$20,$14,$01,$02,$22,$43,$42,$10,$13;10
 db $44,$20,$14,$00,$23,$31,$01,$33,$10,$42;11
 db $01,$11,$44,$04,$14,$31,$03,$21,$04,$13;12
 db $31,$11,$02,$24,$10,$33,$32,$02,$33,$03;13
 db $24,$03,$11,$23,$02,$40,$04,$00,$23,$04;14
 db $21,$22,$44,$34,$14,$34,$44,$02,$02,$34;15
 db $21,$34,$20,$13,$23,$30,$00,$43,$41,$43;16

lev14:
 db 11
 db 1
 db $20,$03,$31,$24,$14,$00,$40,$40,$23,$01;1
 db $40,$00,$42,$12,$20,$21,$41,$33,$12,$03;2
 db $34,$04,$00,$40,$34,$03,$12,$10,$22,$43;3
 db $02,$41,$20,$33,$43,$34,$41,$03,$02,$04;4
 db $31,$01,$33,$34,$24,$40,$41,$33,$23,$10;5
 db $41,$43,$01,$41,$14,$42,$23,$21,$43,$00;6
 db $22,$34,$13,$31,$10,$43,$20,$11,$30,$21;7
 db $42,$03,$42,$00,$21,$44,$32,$40,$21,$43;8
 db $43,$00,$31,$41,$34,$43,$40,$02,$34,$14;9
 db $22,$41,$12,$41,$33,$11,$00,$31,$14,$23;10
 db $20,$23,$04,$31,$12,$04,$23,$32,$31,$30;11
 db $12,$42,$41,$01,$32,$22,$23,$41,$31,$24;12
 db $20,$44,$24,$10,$12,$41,$24,$04,$11,$02;13
 db $22,$31,$10,$12,$01,$02,$40,$21,$22,$24;14
 db $34,$02,$03,$31,$40,$33,$31,$41,$14,$30;15
 db $02,$14,$13,$02,$31,$02,$01,$21,$33,$23;16

lev15:
 db 4
 db 12
 db $30,$32,$22,$44,$41,$42,$41,$10,$31,$40;1
 db $13,$02,$12,$41,$44,$14,$13,$12,$10,$14;2
 db $12,$01,$31,$02,$03,$31,$41,$30,$30,$44;3
 db $42,$43,$42,$21,$04,$14,$00,$31,$23,$22;4
 db $01,$24,$20,$43,$43,$02,$23,$33,$40,$02;5
 db $21,$01,$33,$00,$00,$20,$21,$24,$43,$42;6
 db $22,$40,$03,$40,$34,$10,$12,$13,$02,$32;7
 db $44,$04,$20,$03,$44,$31,$40,$24,$23,$14;8
 db $00,$41,$40,$43,$11,$34,$20,$21,$41,$12;9
 db $31,$23,$02,$00,$23,$34,$02,$32,$30,$12;10
 db $00,$21,$13,$41,$14,$22,$22,$24,$30,$02;11
 db $44,$00,$32,$34,$23,$21,$30,$43,$13,$12;12
 db $30,$44,$13,$13,$04,$31,$31,$42,$10,$00;13
 db $03,$30,$22,$13,$11,$13,$11,$23,$04,$21;14
 db $03,$01,$44,$23,$13,$00,$22,$14,$44,$44;15
 db $03,$11,$31,$21,$23,$32,$31,$14,$30,$43;16

lev16:
 db 9
 db 7
 db $02,$31,$12,$11,$00,$22,$24,$32,$14,$44;1
 db $34,$03,$32,$24,$13,$04,$00,$20,$02,$23;2
 db $24,$11,$13,$12,$04,$13,$31,$34,$34,$03;3
 db $11,$04,$10,$33,$31,$02,$32,$34,$23,$14;4
 db $10,$22,$10,$00,$30,$23,$24,$43,$41,$24;5
 db $03,$33,$22,$30,$10,$24,$13,$44,$41,$02;6
 db $23,$43,$14,$01,$03,$32,$13,$33,$20,$34;7
 db $03,$34,$21,$13,$01,$44,$41,$22,$44,$24;8
 db $43,$12,$10,$42,$32,$00,$02,$14,$42,$23;9
 db $04,$31,$11,$04,$12,$34,$11,$10,$40,$44;10
 db $13,$44,$22,$13,$32,$10,$00,$24,$31,$21;11
 db $24,$02,$21,$21,$20,$11,$34,$34,$00,$04;12
 db $02,$20,$10,$14,$12,$33,$04,$21,$23,$34;13
 db $32,$03,$44,$40,$01,$14,$21,$00,$01,$30;14
 db $44,$42,$42,$23,$43,$40,$11,$10,$13,$01;15
 db $34,$11,$22,$30,$03,$21,$32,$00,$43,$20;16

keyta:
 db $EF,1;0
 db $F7,1;1
 db $F7,2;2
 db $F7,4;3
 db $F7,8;4
 db $F7,16;5
 db $EF,16;6
 db $EF,8;7
 db $EF,4;8
 db $EF,3;9
 db $FD,1;A
 db $7F,16;B
 db $FE,8;C
 db $FD,4;D
 db $FB,4;E
 db $FD,8;F
decnum:
; db "00000000001111111"
;decnum2:
 db "0123456789ABCDEF"
fnt:incbin "inerf.fnt"
msg2:
	dw 24*128+42 ;90
	db $FF
	db "Failed(space)",0

msg3:
	dw 24*128+42-4 ;90
	db $FF
	db "Done!(space)",0

msg4:
	dw 0
	db $ff
	db "Choose Level(0-F)",0

msgl: dw 0
 db $ff
 db "level:"
l_n: db "0",0
end
 LUA
 os.remove("inertia.dsk")
 ENDLUA
;	display/d,end-begin
	savebin "iner",begin,end-begin
	shellexec "mgtman -wc inertia.dsk iner 32768 32768"
	display cas1